let ddlAttendees = [];
let invitedAttendees = [];
Office.initialize = function () {
  //  initialize data  
  Office.context.mailbox.item.addHandlerAsync(
    Office.EventType.EnhancedLocationsChanged,
    function (eventArgs) {
      let enhancedLocations = eventArgs.enhancedLocations;
    }
  );

};

Office.onReady((info) => {
  if (info.host === Office.HostType.Outlook) {

    $.ajax({
      url: 'http://127.0.0.1:8000/api/login',
      type: 'POST',
      data: {
        email: 'admin1@admin.com',
        password: 'password',
      },
      success: function (response) {
        localStorage.setItem('api_token', response.token);
        localStorage.setItem('tenant_id', response.tenant_id);

        $.ajax({
          url: 'http://127.0.0.1:8000/api/branding',
          type: 'GET',
          data:{
            "tenant_id":"1"
          },
          headers: {
            'Authorization': 'Bearer ' + localStorage.getItem('api_token')
          },
          success: function (response) {
            debugger;
          },
          error: function (xhr) {
          }
        });

      },
      error: function (xhr) {
      }
    });
    
    $('#app-body').css("display", "block");
    getAllLocations();
    getUsers();

    var previousAttendees = [];
    var pollingInterval = 1000;

function checkAttendees() {
  Office.context.mailbox.item.requiredAttendees.getAsync(function (asyncResult) {
      if (asyncResult.status === Office.AsyncResultStatus.Succeeded) {
          var currentAttendees = asyncResult.value;
          if (!areArraysEqual(previousAttendees, currentAttendees)) {

              console.log("previousAttendees:",previousAttendees);
              console.log("currentAttendees:",currentAttendees);
              invitedAttendees = [];
              invitedAttendees = currentAttendees;
              previousAttendees = currentAttendees;
              asyncDDL();
          }
      } else {
          console.log("Failed to get attendees: " + asyncResult.error.message);
      }
      setTimeout(checkAttendees, pollingInterval);
  });
}

checkAttendees();

function areArraysEqual(arr1, arr2) {
  if (arr1.length !== arr2.length) return false;
  for (var i = 0; i < arr1.length; i++) {
      if (arr1[i].emailAddress !== arr2[i].emailAddress) return false;
  }
  return true;
}
  }
});



$('#ddlVisitors').on('change', function (e) {
  
  var attendees = [{
    "displayName": $('#ddlVisitors :selected').text(),
    "emailAddress": $('#ddlVisitors').val()
  }];
  debugger;
  Office.context.mailbox.item.requiredAttendees.setAsync(
    attendees, function (asyncResult) {
      if (asyncResult.status == Office.AsyncResultStatus.Failed) {
        debugger;
        write(asyncResult.error.message);
      }
    });
});


$('#dara-location').on('change', function (e) {
  let location = $(this).find(':selected').attr('data-location')
  Office.context.mailbox.item.location.setAsync(
    location,
    function (asyncResult) {
      if (asyncResult.status === Office.AsyncResultStatus.Succeeded) {
        localStorage.setItem('location', location);
      } else {

      }
    }
  );
});

function addAttendees(value) {
  var attendees = [{
    "displayName": $('#ddlVisitors :selected').text(),
    "emailAddress": $('#ddlVisitors').val()
  }];

  Office.context.mailbox.item.requiredAttendees.setAsync(
    attendees, function (asyncResult) {
      if (asyncResult.status == Office.AsyncResultStatus.Failed) {
        debugger;
        write(asyncResult.error.message);
      }
    });

}

function getAddedAttendees() {
  Office.context.mailbox.item.requiredAttendees.getAsync(function (asyncResult) {
      if (asyncResult.status === Office.AsyncResultStatus.Succeeded) {
          var addedAttendees = asyncResult.value;
          
          for (var i = 0; i < addedAttendees.length; i++) {
              var displayName = addedAttendees[i].displayName;
              var emailAddress = addedAttendees[i].emailAddress;
              console.log('Added Attendee Display Name: ' + displayName);
              console.log('Added Attendee Email Address: ' + emailAddress);
          }
      } else {
      }
  });
}


function getAllLocations() {
  $.ajax({
    url: "https://jsonplaceholder.typicode.com/todos", success: function (result) {
      let html = "<option value=''></option>";
      result.forEach(element => {
        html += `<option data-location='${element.title}' value='${element.id}'>${element.title}</option>`
      });
      $('#dara-location').html(html);
    }
  });
}

async function insertContosoMeeting(event) {
}

function getUsers() {

  $.ajax({
    url: 'http://127.0.0.1:8000/api/visitors',
    type: 'GET',
    headers: {
      'Authorization': 'Bearer ' + localStorage.getItem('api_token')
    },
    success: function (response) {
      ddlAttendees = response;
      asyncDDL();
    },
    error: function (xhr) {
    }
  });

  
}

function asyncDDL(){
  $('#ddlVisitors').empty();
  //$('#ddlVisitors').append('<option value="0">test</option>');
  for (var i = 0; i < ddlAttendees.length; i++) {
    $('#ddlVisitors').append('<option value="' + ddlAttendees[i].email + '">' + ddlAttendees[i].name + '</option>');
  }
  for (var i = 0; i < invitedAttendees.length; i++) {
    $('#ddlVisitors').append('<option value="' + invitedAttendees[i].emailAddress + '" selected>' + invitedAttendees[i].displayName + '</option>');
  }
}




